Subject: Re: [PATCH/RFC] rebase: make resolve message clearer for inexperienced users

From: William Duclot <[email-masked]>
Date: Mon, 10 Jul 2017 20:31:01 +0200

Junio C Hamano writes:
> William Duclot <[email-masked]> writes:
> 
> > diff --git a/git-rebase.sh b/git-rebase.sh
> > index 2cf73b88e..50457f687 100755
> > --- a/git-rebase.sh
> > +++ b/git-rebase.sh
> > @@ -55,9 +55,10 @@ LF='
> >  '
> >  ok_to_skip_pre_rebase=
> >  resolvemsg="
> > -$(gettext 'When you have resolved this problem, run "git rebase --continue".
> > -If you prefer to skip this patch, run "git rebase --skip" instead.
> > -To check out the original branch and stop rebasing, run "git rebase --abort".')
> > +$(gettext 'Resolve this conflict manually, mark it as resolved with "git add <conflicted_file>",
> > +then run "git rebase --continue".
> > +You can instead skip this commit: run "git rebase --skip".
> > +To stop the whole rebasing and get back to your pre-rebase state, run "git rebase --abort".')
> >  "
> 
> I find the updated one easier to follow in general.
> Disecting the phrases in the above:
> 
>  - The original said "When you have resolved this problem", without
>    giving a guidance how to resolve, and without saying what the
>    problem is.  The updated one says "conflict" to clarify the
>    "problem", and suggests "git add" as the tool to use after a
>    manual resolition.  
> 
>    Modulo that there are cases where "git rm" is the right tool, the
>    updated one is strict improvement.

I also wrote "<conflicted_file>" when there could be several. Maybe
'mark it as resolved with "git add/rm"' would be a better (and shorter)
formulation?

>  - The original said "to check out the original branch and stop
>    rebasing", and the updated one says "to stop and get back to",
>    which is in a more logical order.  
> 
>    "the whole rebasing" used as a noun feels something is missing
>    there, though.  I wonder if "To get back to the state before you
>    started 'rebase -i', run 'git rebase --abort'" is sufficient,
>    without saying anything further about abandoning the rebase in
>    progress (i.e. "and stop rebasing" or "stop the whole rebasing").

Definitely seems clearer to me: straight to the point.

> Thanks.

Happy to see this patch seems interesting to you. I feel like a lot of
git messages could be improved this way to offer a UI more welcoming to
inexperienced user (which is a *broad* segment of users). But I am not
aware of the cost of translation of this kind of patch: would several
patches like this one be welcomed?